#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <dbus/dbus-glib.h>

const gchar *hplip_helper[] = { "/usr/bin/hplip-plugin-ubuntu", NULL };

static void
on_dbus_need_plugin_event (DBusGProxy *proxy, void *data)
{
   GError *error = NULL;

   fprintf(stderr, "need firmware\n");
   if(!g_spawn_async("/", hplip_helper, NULL, 0, NULL, NULL, NULL, NULL))
      g_warning(stderr, "error calling hplip_helper");
}

void
hplip_init()
{
   DBusGConnection *connection;
   DBusGProxy *proxy;
   GError *error = NULL;

   connection = dbus_g_bus_get (DBUS_BUS_SYSTEM, &error);
   if (connection == NULL) {
      g_warning("Can not connect to system bus");
      g_error_free (error);
      return;
   }
   proxy = dbus_g_proxy_new_for_name (connection,
				      "com.hp.hplip",
				      "/com/hp/hplip",
				      "com.hp.hplip");
   dbus_g_proxy_add_signal(proxy, "NeedPlugin", G_TYPE_INVALID);
   
   if (proxy == NULL) {
      g_warning("Can not setup proxy");
      return;
   }
   dbus_g_proxy_connect_signal (proxy, "NeedPlugin",
				on_dbus_need_plugin_event,
				NULL, NULL);
}
